unit install;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, winsvc, jpeg, ExtCtrls, CheckLst, Native, Grids, ComCtrls, shellapi,
  WinIOCTL, Global;

type LONG = LongInt; // I hope!
type ULONG = LongWord; // I hope!
type USHORT = Word;//SmallInt; // I Hope!

const
  THIS_VERSION = '0.3';

  EXT2_SUPER_MAGIC : USHORT =	$EF53;
  EXT2_SUPER_MAGIC_SPARSE : USHORT = $FFFF;

  EXT2_GOOD_OLD_REV = 0;  //* The good old (original) format */
  EXT2_DYNAMIC_REV  = 1;  //* V2 format w/ dynamic inode sizes */

  // device states
  DS_UNKNOWN = 0;
  DS_EXT2    = 1;
  DS_EXT3    = 2;

  // Used to identify which version of the driver to install
  OS_NOT_SUPPORTED = 0;
  OS_NT35          = 1;
  OS_NT4           = 2;
  OS_WIN2000       = 3;
  OS_XP            = 4;
  OS_NET           = 5;
  OS_NEW           = 6;

type ext2_super_block = record
	s_inodes_count       : ULONG; // Inodes count
	s_blocks_count       : ULONG;	// Blocks count */
	s_r_blocks_count     : ULONG;	// Reserved blocks count */
	s_free_blocks_count  : ULONG; // Free blocks count */
	s_free_inodes_count  : ULONG; // Free inodes count */
	s_first_data_block   : ULONG;	// First Data Block */
	s_log_block_size     : ULONG;	// Block size */
	s_log_frag_size      : LONG;  // Fragment size */
	s_blocks_per_group   : ULONG;	// # Blocks per group */
	s_frags_per_group    : ULONG;	// # Fragments per group */
	s_inodes_per_group   : ULONG;	// # Inodes per group */
	s_mtime              : ULONG; // Mount time */
	s_wtime              : ULONG;	// Write time */
	s_mnt_count          : USHORT;// Mount count */
	s_max_mnt_count      : SHORT;	// Maximal mount count */
	s_magic              : USHORT;// Magic signature */
	s_state              : USHORT;// File system state */
	s_errors             : USHORT;// Behaviour when detecting errors */
	s_pad                : USHORT;
	s_lastcheck          : ULONG; // time of last check */
	s_checkinterval      : ULONG;	// max. time between checks */
	s_creator_os         : ULONG;	// OS */
	s_rev_level          : ULONG;	// Revision level */
//	s_reserved           : array [0..235] of ULONG;	// Padding to the end of the block */

	s_def_resuid         : USHORT;// Default uid for reserved blocks */
	s_def_resgid         : USHORT;// Default gid for reserved blocks */

   /////////////////////////////////////
   // These are only for revision 1

	s_first_ino           : ULONG; // First non-reserved inode */
	s_inode_size          : USHORT;// size of inode structure */
	s_block_group_nr      : USHORT;// block group # of this superblock */
	s_feature_compat      : ULONG; // compatible feature set */
	s_feature_incompat    : ULONG; // incompatible feature set */
	s_feature_ro_compat   : ULONG; // readonly-compatible feature set */
	s_uuid                : array [0..15] of UCHAR; // 128-bit uuid for volume */
	s_volume_name         : array [0..15] of CHAR;  // volume name */
	s_last_mounted        : array [0..63] of CHAR;  // directory where last mounted */
	s_algorithm_usage_bitmap : ULONG; // For compression */
	// * Performance hints.  Directory preallocation should only
	// * happen if the EXT2_COMPAT_PREALLOC flag is on.
	s_prealloc_blocks     : UCHAR;	// Nr of blocks to try to preallocate*/
	s_prealloc_dir_blocks : UCHAR; // Nr to preallocate for dirs */
	s_padding1            : USHORT;
	s_reserved : array [0..203] of ULONG;	// Padding to the end of the block */

 end;
 Pext2_super_block = ^ext2_super_block;


const EXT3_FEATURE_COMPAT_DIR_PREALLOC	  = $0001;
const EXT3_FEATURE_COMPAT_IMAGIC_INODES  = $0002;
const EXT3_FEATURE_COMPAT_HAS_JOURNAL	  = $0004;
const EXT3_FEATURE_COMPAT_EXT_ATTR		  = $0008;
const EXT3_FEATURE_COMPAT_RESIZE_INODE	  = $0010;
const EXT3_FEATURE_COMPAT_DIR_INDEX		  = $0020;

const EXT3_FEATURE_RO_COMPAT_SPARSE_SUPER	= $0001;
const EXT3_FEATURE_RO_COMPAT_LARGE_FILE	= $0002;
const EXT3_FEATURE_RO_COMPAT_BTREE_DIR	   = $0004;

const EXT3_FEATURE_INCOMPAT_COMPRESSION	= $0001;
const EXT3_FEATURE_INCOMPAT_FILETYPE		= $0002;
const EXT3_FEATURE_INCOMPAT_RECOVER		   = $0004; // Needs recovery
const EXT3_FEATURE_INCOMPAT_JOURNAL_DEV	= $0008; // Journal device

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2b: TTabSheet;
    Label3: TLabel;
    InstallStatus: TLabel;
    DebugTabSheet: TTabSheet;
    Button6: TButton;
    Button1: TButton;
    Button2: TButton;
    Label5: TLabel;
    DriveGrid: TStringGrid;
    Label2: TLabel;
    LetterCombo: TComboBox;
    IntroTabSheet: TTabSheet;
    Memo1: TMemo;
    LocationRadioGroup: TRadioGroup;
    StartupRadioGroup: TRadioGroup;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    InstallButton: TButton;
    UnInstallButton: TButton;
    SaveStep2bButton: TButton;
    TabSheet3: TTabSheet;
    Label8: TLabel;
    Button4: TButton;
    StartButton: TButton;
    Button7: TButton;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    LogTabSheet: TTabSheet;
    DebugMemo: TMemo;
    StatusBar1: TStatusBar;
    UpgradeButton: TButton;
    Button5: TButton;
    Button8: TButton;
    TabSheet2a: TTabSheet;
    Label12: TLabel;
    Label13: TLabel;
    VolumeGrid: TStringGrid;
    Label14: TLabel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button9: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure InstallButtonClick(Sender: TObject);
    procedure UnInstallButtonClick(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DriveGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure SaveStep2bButtonClick(Sender: TObject);
    procedure LetterComboChange(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure TabSheet2bShow(Sender: TObject);
    procedure TabSheet2bHide(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure TabSheet2aShow(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure VolumeGridDblClick(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure UpgradeButtonClick(Sender: TObject);
  private
    { Private declarations }
    SACol : Integer;
    SARow : Integer;
  public
    { Public declarations }
    h : SC_HANDLE;
    OSID : Integer;

    function Connect(Host : String) : Boolean;
    procedure Disconnect;
    function Enum : Boolean;
    function CopyFile(Source : String; Destination : String) : Boolean;
    function ShellCopyFile(Source : String; Destination : String) : Boolean;
    procedure NT_Scan;
    procedure AddDevice(Letter : Char; Device : String; Enabled : Boolean; Status : Integer);
    function SystemDirectory : String;

    function IsServiceStarted : Boolean;
    function GetInstalledVersion : String;
    procedure UpdateInstalledVersion;
    function IdentifyVolumeFS(Volume : String) : String;
    procedure IdentifyVolumeMounts;
    procedure GetListOfMountPoints(List : TStringList);
    procedure PrepareStep2a;
    function GetDosDrives : String;
    procedure UnmountAll(Volume : String);
  end;
  
procedure Debug(S : String);

var
  MainForm: TMainForm;

implementation

uses registry, volume, DriveLetter, winver, MountPoint;

{$R *.DFM}

procedure Debug(S : String);
begin
   MainForm.DebugMemo.Lines.Add(S);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   Version : TOSVersionInfo;
   VersionEx : TOSVersionInfoEx;
   VersionString : String;
   ShowDebug : Boolean;
begin
   // Prevent error messages being displayed by NT
   SetErrorMode(SEM_FAILCRITICALERRORS);
   if Global.SingleInstance('ext2ifs') then exit;

   Label1.Caption := Label1.Caption + THIS_VERSION;

   h := 0;

   ShowDebug := False;
   if ParamCount >= 1 then
   begin
      if ParamStr(1) = '-debug' then
      begin
         ShowDebug := True;
      end
      else if ParamStr(1) = '-start' then
      begin
         StartButtonClick(StartButton);
         Application.Terminate;
         exit;
      end;
   end;
   DebugTabSheet.TabVisible := ShowDebug;
   LogTabSheet.TabVisible := ShowDebug;

   try
      Memo1.Lines.LoadFromFile('readme.txt');
   except
   on E : Exception do
      MessageDlg(E.Message, mtError, [mbOK], 0);
   end;
   PageControl1.ActivePage := IntroTabSheet;

   DriveGrid.Cells[0, 0] := 'Enabled';
   DriveGrid.Cells[1, 0] := 'Drive';
   DriveGrid.Cells[2, 0] := 'Device';
   DriveGrid.Cells[3, 0] := 'File System';

   VolumeGrid.Cells[0, 0] := 'Volume ID';
   VolumeGrid.Cells[1, 0] := 'File System';
   VolumeGrid.Cells[2, 0] := 'Drive';
   VolumeGrid.Cells[3, 0] := 'Path';

   // Identify what OS we are running on
   Version.dwOSVersionInfoSize := Sizeof(Version);
   if GetVersionEx(Version) then
   begin
      case Version.dwPlatformId of
         VER_PLATFORM_WIN32s        : VersionString := 'WIN32s';
         VER_PLATFORM_WIN32_WINDOWS : VersionString := 'Windows 95';
         VER_PLATFORM_WIN32_NT      : VersionString := 'Windows NT';
      else
         VersionString := 'Unknown OS';
      end;
      VersionString := VersionString + ' ' + IntToStr(Version.dwMajorVersion) +
                                       '.' + IntToStr(Version.dwMinorVersion) +
                                       ' build number ' + IntToStr(Version.dwBuildNumber);
      StatusBar1.Panels[1].Text := VersionString;
      if Version.dwPlatformId = VER_PLATFORM_WIN32_NT then
      begin
         // see what version of NT we are running on... (what about build numbers???)
         if Version.dwMajorVersion < 4 then
         begin
            OSID := OS_NT35;
            StatusBar1.Panels[0].Text := 'NT 3.51';
         end
         else if (Version.dwMajorVersion = 4) and (Version.dwMinorVersion = 0) then
         begin
            OSID := OS_NT4;
            StatusBar1.Panels[0].Text := 'NT 4.0';
         end
         else if (Version.dwMajorVersion = 5) and (Version.dwMinorVersion = 0) then
         begin
            OSID := OS_WIN2000;
            StatusBar1.Panels[0].Text := 'Windows 2000';
         end
         else if (Version.dwMajorVersion = 5) and (Version.dwMinorVersion = 1) then
         begin
            OSID := OS_XP; // I think...
            StatusBar1.Panels[0].Text := 'Windows XP';
         end
         else if (Version.dwMajorVersion = 5) and (Version.dwMinorVersion = 2) then
         begin
            OSID := OS_NET; // I think...
            StatusBar1.Panels[0].Text := 'Windows .NET';
         end
         else
         begin
            OSID := OS_NEW;
            StatusBar1.Panels[0].Text := 'Unknown NT Version';
         end;
         StatusBar1.Panels[0].Text := StatusBar1.Panels[0].Text + ' ' + Version.szCSDVersion;
      end
      else
      begin
         OSID := OS_NOT_SUPPORTED;
         StatusBar1.Panels[0].Text := 'Unsuported version';
      end;
   end
   else
   begin
      MessageDlg('Could not get Version info!', mtError, [mbOK], 0);
   end;

   // extended version info
   if True {OSID >= OS_WIN2000} then
   begin
      VersionEx.dwOSVersionInfoSize := Sizeof(VersionEx);
      if GetVersionEx2(VersionEx) then
      begin
         Debug('Major Version      : ' + IntToStr(VersionEx.dwMajorVersion));
         Debug('Minor Version      : ' + IntToStr(VersionEx.dwMinorVersion));
         Debug('Build Number       : ' + IntToStr(VersionEx.dwBuildNumber));
         Debug('Platform ID        : ' + IntToStr(VersionEx.dwPlatformId));
         Debug('CSD Version        : ' + VersionEx.szCSDVersion);
         Debug('Service Pack Major : ' + IntToStr(VersionEx.wServicePackMajor));
         Debug('Service Pack Minor : ' + IntToStr(VersionEx.wServicePackMinor));
         Debug('Suite Mask         : ' + IntToHex(VersionEx.wSuiteMask, 4));
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_SMALLBUSINESS) then
         begin
            Debug('                     Small Business Server');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_ENTERPRISE) then
         begin
            Debug('                     Enterprise Edition');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_BACKOFFICE) then
         begin
            Debug('                     BackOffice');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_COMMUNICATIONS) then
         begin
            Debug('                     Communications');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_TERMINAL) then
         begin
            Debug('                     Terminal Services');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_SMALLBUSINESS_RESTRICTED) then
         begin
            Debug('                     Small Business Server with Restrictive Client License');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_EMBEDDEDNT) then
         begin
            Debug('                     Embedded');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_DATACENTER) then
         begin
            Debug('                     Datacenter Edition');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_SINGLEUSERTS) then
         begin
            Debug('                     Single User Terminal Services');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_PERSONAL) then
         begin
            Debug('                     Home Edition');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_BLADE) then
         begin
            Debug('                     Web Edition');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_EMBEDDED_RESTRICTED) then
         begin
            Debug('                     Embedded Restricted');
         end;
         if MaskBitSet(VersionEx.wSuiteMask, VER_SUITE_SECURITY_APPLIANCE) then
         begin
            Debug('                     Security Appliance');
         end;

         Debug('Product Type       : ' + IntToStr(VersionEx.wProductType));

         if VersionEx.wProductType = VER_NT_WORKSTATION then
         begin
            Debug('                     Workstation');
         end
         else if VersionEx.wProductType = VER_NT_DOMAIN_CONTROLLER then
         begin
            Debug('                     Domain Controller');
         end
         else if VersionEx.wProductType = VER_NT_SERVER then
         begin
            Debug('                     Server');
         end;

      end;

   end;

   if OSID < OS_WIN2000 then
   begin
      TabSheet2a.TabVisible := False;
      TabSheet2b.Caption := 'Step 2';
   end;
   // should we enable step 2b for 2000+ ??? Only if there are legacy assignments.
   if (OSID >= OS_WIN2000) and (ShowDebug = False) then
   begin
{      if Length(GetDosDrives) = 0 then
      begin
         TabSheet2b.TabVisible := False;
         TabSheet2a.Caption := 'Step 2';
      end;}
   end;

end;

function TMainForm.Connect(Host : String) : Boolean;
var
   Error : DWORD;
begin
   Disconnect;

   h := OpenSCManager(PChar(Host), nil, SC_MANAGER_ALL_ACCESS);

   if h = 0 then
   begin
      Error := GetLastError;
      Debug('OpenSCManager error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
      Result := False;
   end
   else
   begin
//      Debug('Connected to ' + Host);
      Result := True;
   end;
end;

procedure TMainForm.Disconnect;
begin
   if h <> 0 then
   begin
      CloseServiceHandle(h);
      h := 0;
//      Debug('Disconnected');
   end;
end;

function TMainForm.Enum : Boolean;
var
   Buffer : array of TEnumServiceStatus;
   Needed : DWORD;
   Returned : DWORD;
   Resume : DWORD;
   Error : DWORD;
   R : Boolean;
   i : Integer;
   Found : Boolean;
begin
   Found := False;
   SetLength(Buffer, 1);
   Resume := 0;
   {R :=} EnumServicesStatus(h, SERVICE_DRIVER, SERVICE_STATE_ALL, buffer[0], sizeof(Buffer), Needed, Returned, Resume);
   SetLength(Buffer, Needed div sizeof(TEnumServiceStatus) + 1);

   R := EnumServicesStatus(h, SERVICE_DRIVER, SERVICE_STATE_ALL, buffer[0], Needed, Needed, Returned, Resume);
   if R then
   begin
      for i := 0 to Returned - 1 do
      begin
{         if (Buffer[i].ServiceStatus.dwServiceType and SERVICE_FILE_SYSTEM_DRIVER) > 0 then
         begin
            Debug(IntToStr(i) + ' ' + Buffer[i].lpServiceName);
         end;}

         if AnsiCompareText(Buffer[i].lpServiceName, 'ext2fs') = 0 then
         begin
            Found := True;
         end;
      end;
   end
   else
   begin
      Error := GetLastError;
//         if Error = ERROR_MORE_DATA then
      Debug('EnumServicesStatus error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
   end;

   Result := Found;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
   try
      Connect('');
      Enum;
   finally
      Disconnect;
   end;
end;

procedure TMainForm.InstallButtonClick(Sender: TObject);
var
   Error : DWORD;
   Handle : SC_HANDLE;
   Win32Location : String;
   NativeLocation : String;
   StartType : Integer;
   DoInstall : Boolean;
   Reg : TRegistry;
   DriverFileName : String;
   AppPath : String;
begin
   InstallButton.Enabled := False;
   try

      if LocationRadioGroup.ItemIndex = 0 then
      begin
         Win32Location := SystemDirectory + '\drivers\ext2fs.sys';
         NativeLocation := '%SystemRoot%\System32\drivers\ext2fs.sys';
      end
      else
      begin
         Win32Location := 'a:\ext2fs.sys';
         NativeLocation := '\device\floppy0\ext2fs.sys';
      end;

      // copy file to \\hostname\Admin$\System32\drivers
      // Depending on what OS version are running we have to copy a different file
      DriverFileName := 'ext2fs.sys';
      if OSID = OS_NT4 then
      begin
         DriverFileName := 'ext2fsnt4chk.sys';
      end
      else if OSID >= OS_WIN2000 then
      begin
         DriverFileName := 'ext2fsnt5chk.sys';
      end
      else
      begin
         MessageDlg('This version of Windows is not supported', mtWarning, [mbOK], 0);
         exit;
      end;

      AppPath := ExtractFilePath(Application.ExeName);

      // Make sure we can find the source file....
      if FileExists(AppPath + DriverFileName) then
      begin
         DriverFileName := AppPath + DriverFileName;
         DoInstall := True;
      end
      else
      begin
         // perhaps we are on a development machine
         if FileExists(AppPath + '..\driver\' + DriverFileName) then
         begin
            DriverFileName := AppPath +  '..\driver\' + DriverFileName;
            DoInstall := True;
         end
         else
         begin
            MessageDlg('The driver file ''' + DriverFileName + '''can not be found.  Try downloading the package again.', mtError, [mbOK], 0);
            DoInstall := False;
         end;
      end;

      if DoInstall and ShellCopyFile(DriverFileName, Win32Location) then
      begin
         DoInstall := True;
      end
      else
      begin
         if MessageDlg('The file was not successfuly copied.  Do you still want to install the service?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         begin
            DoInstall := True;
         end
         else
         begin
            DoInstall := False;
         end;
      end;

      if DoInstall then
      begin
         if StartupRadioGroup.ItemIndex = 0 then
         begin
            StartType := SERVICE_SYSTEM_START;
         end
         else
         begin
            StartType := SERVICE_DEMAND_START;
         end;
         Connect('');
         try
            Handle := CreateService( h,
                           'Ext2FS',
                           'Ext2FS',
                           SERVICE_ALL_ACCESS,
                           SERVICE_FILE_SYSTEM_DRIVER,
                           StartType,
                           SERVICE_ERROR_NORMAL,
                           PChar(NativeLocation),
                           'Boot file system',
                           nil,
                           nil,
                           nil,
                           nil);

            if Handle = 0 then
            begin
               Error := GetLastError;
               Debug('CreateService error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
            end
            else
            begin
               Debug('Service created');
               CloseServiceHandle(Handle);
               // update the location manualy....
               Reg := TRegistry.Create;
               try
                  Reg.RootKey := HKEY_LOCAL_MACHINE;
                  Reg.OpenKey('\SYSTEM\CurrentControlSet\Services\Ext2FS',False);
                  if LocationRadioGroup.ItemIndex = 0 then
                  begin
                     Reg.DeleteValue('ImagePath');
                  end
                  else
                  begin
                     Reg.WriteString('ImagePath', NativeLocation);
                  end;
               finally
                  Reg.Free;
               end;
               UpdateInstalledVersion;
            end;
         finally
            Disconnect;
         end;
      end;
   finally
      TabSheet1Show(TabSheet1);
   end;
end;

procedure TMainForm.UnInstallButtonClick(Sender: TObject);
var
   Error : DWORD;
   Handle : SC_HANDLE;
   Reg : TRegistry;
begin
   UnInstallButton.Enabled := False;


   if IsServiceStarted then
   begin
      MessageDlg('The service is currently started.  You will have to reboot before the service is completely uninstalled.', mtInformation, [mbOK], 0);
   end;

   try
      // clear the path from the registry.
      Reg := TRegistry.Create;
      try
         Reg.RootKey := HKEY_LOCAL_MACHINE;
         Reg.OpenKey('\SYSTEM\CurrentControlSet\Services\Ext2FS',False);
         //Reg.WriteString('ImagePath', '');
         Reg.DeleteValue('ImagePath');
      finally
         Reg.Free;
      end;

      Connect('');
      try
         Handle := OpenService(h, 'Ext2FS', SERVICE_ALL_ACCESS);

         if Handle = 0 then
         begin
            Error := GetLastError;
            Debug('OpenService error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
         end
         else
         begin
            Debug('Service opened');

            if DeleteService(Handle) then
            begin
               Debug('Service deleted');
            end
            else
            begin
               Error := GetLastError;
               Debug('DeleteService error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
            end;
            CloseServiceHandle(Handle);
         end;
      finally
         Disconnect;
      end;
   finally
      TabSheet1Show(TabSheet1);
   end;
end;

procedure TMainForm.StartButtonClick(Sender: TObject);
var
   Error : DWORD;
   Handle : SC_HANDLE;
   Args : PAnsiChar;
begin
   Connect('');
   Handle := OpenService(h, 'Ext2FS', SERVICE_ALL_ACCESS);

   if Handle = 0 then
   begin
      Error := GetLastError;
      Debug('OpenService error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
   end
   else
   begin
      Debug('Service opened');

      Args := nil;
      if StartService(Handle, 0, Args) then
      begin
         Debug('Service started');
      end
      else
      begin
         Error := GetLastError;
         Debug('StartService error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
      end;
   end;
   Disconnect;

   TabSheet3Show(TabSheet3);
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
//   CopyFile;
end;

function TMainForm.SystemDirectory : String;
begin
   SetLength(Result, MAX_PATH);
   GetSystemDirectory(PChar(Result), MAX_PATH);
   SetLength(Result, StrLen(PChar(Result)));
end;

function TMainForm.CopyFile(Source : String; Destination : String) : Boolean;
var
   Error : DWORD;
   Finish : Boolean;
//   Source : String;
begin
   Result := False;
   Finish := False;
//   Source := ExtractFilePath(Application.ExeName) +  'ext2fs.sys';

   while not Finish do
   begin

      if Windows.CopyFile(Pchar(Source), PChar(Destination), False) then
      begin
         Result := True;
         Debug('File installed');
         Finish := True;
      end
      else
      begin
         Error := GetLastError;
         Debug('CopyFile error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
         if MessageDlg('The file could not be copied.  The error was'#10 + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ').'#10#10'Do you want to try again?', mtError, [mbYes, mbNo], 0) = mrNo then
         begin
            Finish := True;
         end;
      end;
   end;
end;

function TMainForm.ShellCopyFile(Source : String; Destination : String) : Boolean;
var
   FileOp      : TSHFILEOPSTRUCT;
   FromFile    : PChar;
   ToFile      : PChar;
begin
   if FileExists(Destination) then
   begin
      DeleteFile(Destination);
   end;

   FromFile := StrAlloc(Length(Source) + 2);
   ZeroMemory(FromFile, Length(Source) + 2);
   Move(PChar(Source)^, FromFile^, Length(Source));

   ToFile := StrAlloc(Length(Destination) + 2);
   ZeroMemory(ToFile, Length(Destination) + 2);
   Move(PChar(Destination)^, ToFile^, Length(Destination));

   ZeroMemory(@FileOp, SizeOf(FileOp));
   FileOp.Wnd := Handle;
   FileOp.wFunc := FO_COPY;
   FileOp.pFrom := FromFile;
   FileOp.pTo := ToFile;
   FileOp.fFlags := FOF_NOCONFIRMATION;// or FOF_SIMPLEPROGRESS;
   //FileOp.lpszProgressTitle := 'Copying database';

   SHFileOperation(FileOp);

   StrDispose(FromFile);
   StrDispose(ToFile);

   Result := True;
end;

function TMainForm.GetDosDrives : String;
var
   Reg : TRegistry;
   Drive : Char;
begin
   Result := '';
   // drive letters are assigned with
   // HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\DOS Devices
   // J: = \Device\Harddisk2\Partition1

   Reg := TRegistry.Create;
   try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      Reg.OpenKey('\SYSTEM\CurrentControlSet\Control\Session Manager\DOS Devices',False);
      for Drive := 'A' to 'Z' do
      begin
         if Reg.ValueExists(drive + ':') then
         begin
            Result := Result + Drive;
         end;
      end;
   finally
      Reg.Free;
   end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
   Reg : TRegistry;
   Drive : Char;
begin
   NT_Scan;
   // drive letters are assigned with
   // HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\DOS Devices
   // J: = \Device\Harddisk2\Partition1

   Reg := TRegistry.Create;
   try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      Reg.OpenKey('\SYSTEM\CurrentControlSet\Control\Session Manager\DOS Devices',False);
      for Drive := 'A' to 'Z' do
      begin
         if Reg.ValueExists(drive + ':') then
         begin
            Debug(drive + ': = ' + Reg.ReadString(drive + ':'));
            AddDevice(drive, Reg.ReadString(drive + ':'), True, DS_UNKNOWN);
         end;
      end;
   finally
      Reg.Free;
   end;
   LetterCombo.Visible := False;
end;

procedure TMainForm.AddDevice(Letter : Char; Device : String; Enabled : Boolean; Status : Integer);
var
   Row : Integer;
   Replaced : Boolean;
begin
   Replaced := False;
   if DriveGrid.Enabled then
   begin
      for Row := 1 to DriveGrid.RowCount - 1 do
      begin
         if AnsiSameText(DriveGrid.Cells[2, Row], Device) then
         begin
            // upgrade the drive letter and active
            if Enabled then
            begin
               DriveGrid.Cells[0, Row] := 'Yes';
            end
            else
            begin
               DriveGrid.Cells[0, Row] := 'No';
            end;
            DriveGrid.Cells[1, Row] := Letter;
            Replaced := True;
            break;
         end
      end;
   end;

   if not Replaced then
   begin
      if DriveGrid.Enabled then
      begin
         Row := DriveGrid.RowCount;
         DriveGrid.RowCount := DriveGrid.RowCount + 1;
      end
      else
      begin
         DriveGrid.Enabled := True;
         Row := 1;
         SaveStep2bButton.Enabled := True;
      end;

      if Enabled then
      begin
         DriveGrid.Cells[0, Row] := 'Yes';
      end
      else
      begin
         DriveGrid.Cells[0, Row] := 'No';
      end;
      if Letter = '-' then
      begin
         DriveGrid.Cells[1, Row] := Letter;
      end
      else
      begin
         DriveGrid.Cells[1, Row] := Letter + ':';
      end;
      DriveGrid.Cells[2, Row] := Device;

      if Status = DS_EXT2 then
      begin
         DriveGrid.Cells[3, Row] := 'EXT2';
      end
      else if Status = DS_EXT3 then
      begin
         DriveGrid.Cells[3, Row] := 'EXT3';
      end
      else
      begin
         DriveGrid.Cells[3, Row] := 'Unknown';
      end;
   end;
end;

procedure TMainForm.NT_Scan;
var
   DriveNo    : Integer;
   PartNo     : Integer;
   DeviceName : String;
   h          : THandle;
   Done       : Boolean;
   ErrorNo    : DWORD;
   Superblock : ext2_super_block;
   Actual     : DWORD;
   Status     : Integer;
begin
   DriveNo := 0;

   Done := False;

   while not Done do
   begin
      PartNo := 0;
      while True do
      begin
         DeviceName := '\Device\Harddisk' + IntToStr(DriveNo) + '\Partition' + IntToStr(PartNo);

         // try and open the file.
         h := NTCreateFile(PChar(DeviceName), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, 0);

         if h <> INVALID_HANDLE_VALUE then
         begin
            try
            // check for Ext2
//               Debug('Opened ' + DeviceName, DebugLow);

               if NTReadFile2(h, @superblock, sizeof(superblock), Actual, nil) then
               begin
                  if Actual = sizeof(superblock) then
                  begin
//                     Debug('read superblock', DebugOff);
                     // check the magic number
                     if superblock.s_magic = EXT2_SUPER_MAGIC then
                     begin
                        Debug(DeviceName);
                        Debug('EXT2 Found. magic = 0x' + IntToHex(superblock.s_magic, 4));

                        Status := DS_EXT2;
                        if Superblock.s_rev_level > 0 then
                        begin
                           Debug(superblock.s_volume_name);
                           if (Superblock.s_feature_compat and EXT3_FEATURE_COMPAT_HAS_JOURNAL) = EXT3_FEATURE_COMPAT_HAS_JOURNAL then
                           begin
                              Debug('EXT3');
                              Status := DS_EXT3;
                           end;
                        end;

                        AddDevice('-', DeviceName, False, Status);

                        // Add a record...
{                        NewPart := TPartition.Create;
                        Partitions.add(NewPart);

                        NewPart.DriveNo := DriveNo;
                        NewPart.PartNo := PartNo;
                        NewPart.FileName := DeviceName;
                        NewPart.BytesPerSector     := 512;
                        NewPart.MediaType          := Media_Type_FixedMedia;
                        NewPart.PartitionType            := PARTITION_LINUX;
                        NewPart.RecognizedPartition      := True;
                        NewPart.RewritePartition         := False;
                        NewPart.StartingOffset.QuadPart  := 0;
                        NewPart.PartitionLength.QuadPart := $FFFFFFFFFFFFFFFF;
                        NewPart.HiddenSectors            := 0;}

                     end;
                  end
                  else
                  begin
                     Debug('Only read ' + IntToStr(Actual) + ' bytes');
                  end;
               end
               else
               begin
                  Debug('Error reading file ' + IntToStr(GetLastError) + ' ' + SysErrorMessage(GetLastError));
               end;
            finally
               CloseHandle(h);
            end;
         end
         else
         begin
            ErrorNo := Native.GetLastError;
//   Debug('GetLastError = (' + IntToStr(ErrorNo) + ') ' + SysErrorMessage(ErrorNo), DebugOff);
            if ErrorNo = ERROR_FILE_NOT_FOUND then
            begin
               if PartNo = 0 then
               begin
                  Done := True;
               end;
               break;
            end
            else if ErrorNo = ERROR_PATH_NOT_FOUND then
            begin
               Done := True;
               break;
            end;
         end;
         PartNo := PartNo + 1;
      end;
      DriveNo := DriveNo + 1;
   end;
end;


procedure TMainForm.DriveGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var
   Rect : TRect;
begin
   if (ACol <> SACol) or (ARow <> SARow) then
   begin
{      if LetterCombo.Visible = True then
      begin
         // Save the value
         DriveGrid.Cells[SACol, SARow] := LetterCombo.Text;
      end;}

      if ACol = 1 then
      begin
         Rect := DriveGrid.CellRect(ACol, ARow);
         LetterCombo.Left := DriveGrid.Left + Rect.Left + 1;
         LetterCombo.Top := DriveGrid.Top + Rect.Top + 1;
         LetterCombo.Width := Rect.Right - Rect.Left + 3;
         LetterCombo.Height := Rect.Bottom - Rect.Top - 2;
         LetterCombo.Text := DriveGrid.Cells[ACol, ARow];
         LetterCombo.Visible := True;
         SACol := ACol;
         SARow := ARow;
      end
      else
      begin
         SACol := 0;
         SARow := 0;
         LetterCombo.Visible := False;
      end;
   end;
end;

procedure TMainForm.SaveStep2bButtonClick(Sender: TObject);
var
   Required : TStringList;
   i : Integer;
   Reg : TRegistry;
   Drive : Char;
   Exist : Boolean;
begin
   LetterCombo.Visible := False;
   SaveStep2bButton.Enabled := False;
   SACol := 0;
   SARow := 0;

   // make the drive letter assignments look like the grid...
   Required := TStringList.Create;

   for i := 1 to DriveGrid.RowCount  - 1 do
   begin
      if DriveGrid.Cells[1, i] <> '-' then
      begin
         //Debug(DriveGrid.Cells[1, i] + ' -> ' + DriveGrid.Cells[2, i]);
         Required.AddObject(DriveGrid.Cells[2, i], TObject(Ord(DriveGrid.Cells[1, i][1])));
      end;
   end;

   // we should so sanity checks...
   // are any drive letters duplicated?
   // are and drive letters currently in use?
   // are we removeing a non ext2 drive letter?

//   for i := 0 to Required.Count - 1 do
//   begin
//      Debug(Required[i] + ' -> ' + Chr(Integer(Required.Objects[i])) + ':');
//   end;

   Reg := TRegistry.Create;
   try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      Reg.OpenKey('\SYSTEM\CurrentControlSet\Control\Session Manager\DOS Devices',False);

      for i := 0 to Required.Count - 1 do
      begin
//         Debug(Required[i] + ' -> ' + Chr(Integer(Required.Objects[i])) + ':');
         Drive := Chr(Integer(Required.Objects[i]));

         if Reg.ValueExists(drive + ':') then
         begin
            if AnsiSameText(Reg.ReadString(drive + ':'), Required[i]) then
            begin
               Debug(Required[i] + ' -> ' + Drive + ': Already exists');
               // this entry already exists so we can skip it
            end
            else
            begin
               Debug(Required[i] + ' -> ' + Drive + ': Needs to be updated');
               // the entry needs to be changed
               if MessageDlg('The drive ' + Drive + ': needs to be updated to point to ' + Required[i] + #10'Do you want to make this change?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
               begin
                  Reg.WriteString(drive + ':', Required[i]);
               end;
            end;
         end
         else
         begin
            Debug(Required[i] + ' -> ' + Drive + ': Needs to be added');
            if MessageDlg('The drive ' + Drive + ': needs to be added and pointed to ' + Required[i] + #10'Do you want to make this change?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
               Reg.WriteString(drive + ':', Required[i]);
            end;
            // the entry needs to be added
         end;
      end;

      // now we need to check for drives which have been removed...
      for Drive := 'A' to 'Z' do
      begin
         Exist := False;
         if Reg.ValueExists(drive + ':') then
         begin
            //Reg.ReadString(drive + ':');
            // search for a device....
            for i := 0 to Required.Count - 1 do
            begin
               if Chr(Integer(Required.Objects[i])) = Drive then
               begin
                  // should exist.
                  Exist := True;
                  break;
               end;
            end;
            if not Exist then
            begin
               if MessageDlg('The drive ' + Drive + ': needs to be removed.  It currently points to ' + Reg.ReadString(drive + ':') + #10'Do you want to make this change?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
               begin
                  Reg.DeleteValue(drive + ':');
               end;
            end;
         end;
      end;

   finally
      Reg.Free;
   end;


   Required.Free;

   Button1Click(Button1);

   // Flag step 2a to be refreshed
   VolumeGrid.RowCount := 2;
   VolumeGrid.Enabled := False;
end;

procedure TMainForm.LetterComboChange(Sender: TObject);
begin
   DriveGrid.Cells[SACol, SARow] := LetterCombo.Text;
end;

function TMainForm.GetInstalledVersion : String;
var
   Reg : TRegistry;
begin
   Result := '';

   try
      Reg := TRegistry.Create;
      try
         Reg.RootKey := HKEY_LOCAL_MACHINE;
         if Reg.OpenKey('\SOFTWARE\Newbigin\Ext2FS',False) then
         begin
            Result := Reg.ReadString('Version');
         end;
      finally
         Reg.Free;
      end;
   except
      // ignore invalid registry data
   end;
end;

procedure TMainForm.UpdateInstalledVersion;
var
   Reg : TRegistry;
begin
   try
      Reg := TRegistry.Create;
      try
         Reg.RootKey := HKEY_LOCAL_MACHINE;
         if Reg.OpenKey('\SOFTWARE\Newbigin\Ext2FS',True) then
         begin
            Reg.DeleteKey('Version');
            Reg.WriteString('Version', THIS_VERSION);
         end;
      finally
         Reg.Free;
      end;
   except
      // ignore invalid registry data
   end;
end;

procedure TMainForm.TabSheet1Show(Sender: TObject);
begin
   UpgradeButton.Visible := False;

   try
      Connect('');
      if Enum then
      begin
         Debug('Driver is installed');
         UnInstallButton.Enabled := True;
         InstallButton.Enabled := False;
         LocationRadioGroup.Enabled := False;
         StartupRadioGroup.Enabled := False;
         InstallStatus.Caption := 'The driver is currently installed';

         // Get installed version number
         if (GetInstalledVersion <> THIS_VERSION) then
         begin
            // allow upgrade
            UpgradeButton.Visible := True;
         end;
      end
      else
      begin
         Debug('Driver is not installed');
         InstallButton.Enabled := True;
         UnInstallButton.Enabled := False;
         LocationRadioGroup.Enabled := True;
         StartupRadioGroup.Enabled := True;
         InstallStatus.Caption := 'The driver is not installed';

         // set defaults depending on what OS we are on
         if OSID = OS_WIN2000 then
         begin
            StartupRadioGroup.ItemIndex := 0;
         end;
      end;
   finally
      Disconnect;
   end;
end;

procedure TMainForm.TabSheet2bShow(Sender: TObject);
begin
   if not DriveGrid.Enabled then
   begin
      Global.Wait;
      try
         Button1Click(Button1);
      finally
         Global.WaitDone;
      end;
   end;
end;

procedure TMainForm.TabSheet2bHide(Sender: TObject);
begin
   SACol := 0;
   SARow := 0;
   LetterCombo.Visible := False;
end;

procedure TMainForm.Button4Click(Sender: TObject);
var
   Handle : SC_HANDLE;
   Buffer : String;
   Needed : DWORD;
   Error : DWORD;
   Query : PQueryServiceConfig;
   Status : TServiceStatus;
begin
   Debug('Installed version = ' + GetInstalledVersion);
   Connect('');
   try
      Handle := OpenService(h, 'Ext2FS', SERVICE_ALL_ACCESS);

      if Handle = 0 then
      begin
         Error := GetLastError;
         Debug('OpenService error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
      end
      else
      begin
         Debug('Service opened');
         SetLength(Buffer, 1024);
         Query := PQueryServiceConfig((PChar(Buffer)));
         if QueryServiceConfig(Handle, Query, Length(Buffer), Needed) then
         begin
            Debug(Query.lpDisplayName);
            Debug(Query.lpBinaryPathName);
            Debug(Query.lpLoadOrderGroup);
            Debug(Query.lpDependencies);
            Debug(Query.lpServiceStartName);
         end
         else
         begin
            Error := GetLastError;
            Debug('QueryServiceConfig error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
         end;

         if QueryServiceStatus(Handle, Status) then
         begin
            Debug(IntToStr(Status.dwCurrentState));
         end
         else
         begin
            Error := GetLastError;
            Debug('QueryServiceStatus error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
         end;

         CloseServiceHandle(Handle);
      end;
   finally
      Disconnect;
   end;
end;

function TMainForm.IsServiceStarted : Boolean;
var
   Handle : SC_HANDLE;
//   Buffer : String;
//   Needed : DWORD;
   Error : DWORD;
//   Query : PQueryServiceConfig;
   Status : TServiceStatus;
begin
   Result := False;

   Connect('');
   try
      Handle := OpenService(h, 'Ext2FS', SERVICE_ALL_ACCESS);

      if Handle = 0 then
      begin
         Error := GetLastError;
         Debug('OpenService error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
      end
      else
      begin
         Debug('Service opened');

         if QueryServiceStatus(Handle, Status) then
         begin
            Debug(IntToStr(Status.dwCurrentState));
            if Status.dwCurrentState <> SERVICE_STOPPED then
            begin
               Result := True;
            end;
         end
         else
         begin
            Error := GetLastError;
            Debug('QueryServiceStatus error: ' + SysErrorMessage(Error) + ' (' + IntToStr(Error) + ')');
         end;

         CloseServiceHandle(Handle);
      end;
   finally
      Disconnect;
   end;
end;


procedure TMainForm.TabSheet3Show(Sender: TObject);
var
   IsInstalled : Boolean;
begin
   Connect('');
   try
      IsInstalled := Enum;
   finally
      Disconnect;
   end;

   if IsInstalled then
   begin
      if IsServiceStarted then
      begin
         Label9.Visible := True;
         Label10.Visible := False;
         Label11.Visible := False;

         StartButton.Enabled := False;
      end
      else
      begin
         Label9.Visible := False;
         Label10.Visible := True;
         Label11.Visible := False;

         StartButton.Enabled := True;
      end;
   end
   else
   begin
      Label9.Visible := False;
      Label10.Visible := False;
      Label11.Visible := True;
      StartButton.Enabled := False;
   end;
end;

procedure TMainForm.Button5Click(Sender: TObject);
var
   Buffer : String;
   R : DWORD;
   Drive : Char;
   DriveString : String;
begin
   //DefineDosDevice(
   for Drive := 'a' to 'z' do
   begin
      SetLength(Buffer, 1024);
      DriveString := Drive + ':';
      R := QueryDosDevice(PChar(DriveString), PChar(Buffer), Length(Buffer));
      if R > 0 then
      begin
         SetLength(Buffer, R);
         Debug(DriveString + ' = ' + Buffer);
      end;
   end;
end;

procedure TMainForm.Button8Click(Sender: TObject);

   procedure ShowVolumeMountPoints(V : String);
   var
      Buffer : String;
      Buffer2 : String;
      vh : THandle;
      fh : THandle;

      Superblock : ext2_super_block;
      Actual     : DWORD;
      ErrorNo    : DWORD;
   begin
      // If the name ends in '\' then remove it...
      //V := Copy(V, 5, Length(V) - 5);
      //V := '\\.\' + V + '\';

      SetLength(Buffer, 1024);
      vh := JFindFirstVolumeMountPoint(PChar(V), PChar(Buffer), Length(Buffer));
      while vh <> INVALID_HANDLE_VALUE do
      begin
         SetLength(Buffer, strlen(PChar(Buffer)));
         Debug('Mount point = ' + Buffer);

         SetLength(Buffer2, 1024);
         Buffer := V + Buffer;
         if JGetVolumeNameForVolumeMountPoint(PChar(Buffer), PChar(Buffer2), Length(Buffer2)) then
         begin
            SetLength(Buffer2, strlen(PChar(Buffer2)));
            Debug('Volume name = ' + Buffer2);
         end
         else
         begin
            Debug('GetVolumeNameForVolumeMountPoint error ' + IntToStr(GetLastError) + ' ' + SysErrorMessage(GetLastError));
         end;

         SetLength(Buffer, 1024);
         if not JFindNextVolumeMountPoint(vh, PChar(Buffer), Length(Buffer)) then
         begin
            JFindVolumeMountPointClose(vh);
            vh := INVALID_HANDLE_VALUE;
         end;
      end;
      Debug('No more mount points');

      // identify the filesystem.....
      // look for ext magic...
      // If the name ends in '\' then remove it...
      V := Copy(V, 5, Length(V) - 5);
      V := '\\.\' + V;

      fh := CreateFile(PChar(V), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, 0);
      Debug('Opening ' + V + ' fh = ' + IntToStr(fh));

     if fh <> INVALID_HANDLE_VALUE then
      begin
         try
         // check for Ext2
            Debug('Opened ' + V);

            SetFilePointer(fh, 1024, nil, FILE_BEGIN);
            if ReadFile2(fh, @superblock, sizeof(superblock), Actual, nil) then
            begin
               if Actual = sizeof(superblock) then
               begin
                  Debug('read superblock');
                  // check the magic number
                  if superblock.s_magic = EXT2_SUPER_MAGIC then
                  begin
                     //Debug(V);
                     Debug('EXT Found. magic = 0x' + IntToHex(superblock.s_magic, 4));
                     if Superblock.s_rev_level > 0 then
                     begin
                        Debug(superblock.s_volume_name);
                        if (Superblock.s_feature_compat and EXT3_FEATURE_COMPAT_HAS_JOURNAL) = EXT3_FEATURE_COMPAT_HAS_JOURNAL then
                        begin
                           Debug('EXT3');
                        end
                        else
                        begin
                           Debug('EXT2');
                        end;
                     end
                     else
                     begin
                        // only EXT2 with no volume label
                        Debug('EXT2');
                     end;

                     // see if there is a journal flag....


                  end;
               end
               else
               begin
                  Debug('Only read ' + IntToStr(Actual) + ' bytes');
               end;
            end
            else
            begin
               Debug('Error reading file ' + IntToStr(GetLastError) + ' ' + SysErrorMessage(GetLastError));
            end;
         finally
            CloseHandle(fh);
         end;
      end
      else
      begin
         ErrorNo := Windows.GetLastError;//Native.GetLastError;
         Debug('GetLastError = (' + IntToStr(ErrorNo) + ') ' + SysErrorMessage(ErrorNo));
      end;

      Debug('');
      Debug('');
   end;


var
   Buffer : String;
   h : THandle;

   Drive : Char;
   DriveString : String;
begin
   LoadVolume;

   // Enumerate the volumes
   SetLength(Buffer, 1024);

   h := JFindFirstVolume(PChar(Buffer), Length(Buffer));
   if h = INVALID_HANDLE_VALUE then
   begin
      Debug('No volumes found');
   end
   else
   begin
      SetLength(Buffer, strlen(PChar(Buffer)));
      Debug(Buffer);

      ShowVolumeMountPoints(Buffer);

      while True do
      begin
         SetLength(Buffer, 1024);
         if JFindNextVolume(h, PChar(Buffer), Length(Buffer)) then
         begin
            SetLength(Buffer, strlen(PChar(Buffer)));
            Debug(Buffer);

            ShowVolumeMountPoints(Buffer);
         end
         else
         begin
            break;
         end;
      end;
      JFindVolumeClose(h);
   end;

   // Now drive letters....
   for Drive := 'a' to 'z' do
   begin
      DriveString := Drive + ':\';

      SetLength(Buffer, 1024);
      if JGetVolumeNameForVolumeMountPoint(PChar(DriveString), PChar(Buffer), Length(Buffer)) then
      begin
         SetLength(Buffer, strlen(PChar(Buffer)));
         Debug(DriveString + ' = ' + Buffer);
      end;
   end;
end;

function TMainForm.IdentifyVolumeFS(Volume : String) : String;
var
   fh : THandle;

   Superblock  : ext2_super_block;
   Actual      : DWORD;
   ErrorNo     : DWORD;
begin
   Result := '';
   // identify the filesystem.....
   // look for ext magic...
   // Remove leading \\?\ and trailing \
   Volume := Copy(Volume, 5, Length(Volume) - 5);
   Volume := '\\.\' + Volume;

   fh := CreateFile(PChar(Volume), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, 0);

   if fh <> INVALID_HANDLE_VALUE then
   begin
      try
      // check for Ext2

         SetFilePointer(fh, 1024, nil, FILE_BEGIN);
         if ReadFile2(fh, @superblock, sizeof(superblock), Actual, nil) then
         begin
            if Actual = sizeof(superblock) then
            begin
               // check the magic number
               if superblock.s_magic = EXT2_SUPER_MAGIC then
               begin
                  if Superblock.s_rev_level > 0 then
                  begin
//                     Debug(superblock.s_volume_name);
                     if (Superblock.s_feature_compat and EXT3_FEATURE_COMPAT_HAS_JOURNAL) = EXT3_FEATURE_COMPAT_HAS_JOURNAL then
                     begin
                        Result := 'EXT3';
                     end
                     else
                     begin
                        Result := 'EXT2';
                     end;

                     if strlen(Superblock.s_volume_name) > 0 then
                     begin
                        Result := Result + ' (' + Superblock.s_volume_name + ')';
                     end;
                  end
                  else
                  begin
                     // only EXT2 with no volume label
                     Result := 'EXT2';
                  end;
               end;
            end
            else
            begin
               Debug('Only read ' + IntToStr(Actual) + ' bytes');
            end;
         end
         else
         begin
            Debug('Error reading file ' + IntToStr(GetLastError) + ' ' + SysErrorMessage(GetLastError));
         end;
      finally
         CloseHandle(fh);
      end;
   end
   else
   begin
      ErrorNo := Windows.GetLastError;//Native.GetLastError;
      Debug('GetLastError = (' + IntToStr(ErrorNo) + ') ' + SysErrorMessage(ErrorNo));
   end;

end;

procedure TMainForm.GetListOfMountPoints(List : TStringList);
   procedure EnumerateVolumeMountPoints(Volume : String);
   var
      Buffer : String;
      vh : THandle;
   begin
      SetLength(Buffer, 1024);
      vh := JFindFirstVolumeMountPoint(PChar(Volume), PChar(Buffer), Length(Buffer));
      while vh <> INVALID_HANDLE_VALUE do
      begin
         SetLength(Buffer, strlen(PChar(Buffer)));
         Debug('Mount point = ' + Buffer);

         Buffer := Volume + Buffer;
         List.Add(Buffer);

         SetLength(Buffer, 1024);
         if not JFindNextVolumeMountPoint(vh, PChar(Buffer), Length(Buffer)) then
         begin
            JFindVolumeMountPointClose(vh);
            vh := INVALID_HANDLE_VALUE;
         end;
      end;
      Debug('No more mount points');
   end;

var
   Buffer : String;
   h : THandle;
begin
   LoadVolume;

   // Enumerate the volumes
   SetLength(Buffer, 1024);

   h := JFindFirstVolume(PChar(Buffer), Length(Buffer));
   while h <> INVALID_HANDLE_VALUE do
   begin
      SetLength(Buffer, strlen(PChar(Buffer)));
      Debug('FindVolume' + Buffer);
      EnumerateVolumeMountPoints(Buffer);

      SetLength(Buffer, 1024);
      if not JFindNextVolume(h, PChar(Buffer), Length(Buffer)) then
      begin
         JFindVolumeClose(h);
         h := INVALID_HANDLE_VALUE;
      end;
   end;
end;

procedure TMainForm.IdentifyVolumeMounts;
var
   Volume : String;
   Buffer : String;
   Drive        : Char;
   DriveString  : String;
   VolumeLetter : array ['a'..'z'] of String;
   i            : Integer;
   j            : Integer;
   p            : Integer;
   MountPoints  : TStringList;
   MountVolumes : TStringList;
   MountPoint   : String;
   Legacy       : String;
begin
   // Find any drive letter assignments...
   Legacy := LowerCase(GetDosDrives);

   for Drive := 'a' to 'z' do
   begin
      DriveString := Drive + ':\';

      SetLength(Buffer, 1024);
      if JGetVolumeNameForVolumeMountPoint(PChar(DriveString), PChar(Buffer), Length(Buffer)) then
      begin
         SetLength(Buffer, strlen(PChar(Buffer)));
         if Length(Buffer) > 0 then
         begin
            Buffer := Copy(Buffer, 12, Length(Buffer) - 13);
            VolumeLetter[Drive] := Buffer;
            Debug(DriveString + ' = ' + Buffer);
         end;
      end;
   end;

   // Find any mount points
   MountPoints := TStringList.Create;
   MountVolumes := TStringList.Create;
   GetListOfMountPoints(MountPoints);
   for i := 0 to MountPoints.Count - 1 do
   begin
      SetLength(Buffer, 1024);
      if JGetVolumeNameForVolumeMountPoint(PChar(MountPoints[i]), PChar(Buffer), Length(Buffer)) then
      begin
         SetLength(Buffer, StrLen(PChar(Buffer)));
         if Length(Buffer) > 0 then
         begin
            Buffer := Copy(Buffer, 12, Length(Buffer) - 13);
         end;
         MountVolumes.Add(Buffer);
      end
      else
      begin
         MountVolumes.Add('');
      end;
      Debug('MP = ' + MountPoints[i] + ' = ' + MountVolumes[i]);
   end;

   // see where we need to fill in the drive letters...

   for i := 1 to VolumeGrid.RowCount - 1 do
   begin
      VolumeGrid.Cells[2, i] := '';

      Volume := VolumeGrid.Cells[0, i];
      for Drive := 'a' to 'z' do
      begin
         if (Length(Volume) > 0) and (VolumeLetter[Drive] = Volume) then
         begin
            if Pos(Drive, Legacy) > 0 then
            begin
               VolumeGrid.Cells[2, i] := UpperCase(Drive) + '*';
            end
            else
            begin
               VolumeGrid.Cells[2, i] := UpperCase(Drive);
            end;
         end;
      end;
   end;

   // see where we need to fill in mount points
   for i := 1 to VolumeGrid.RowCount - 1 do
   begin
      VolumeGrid.Cells[3, i] := '';
      Volume := VolumeGrid.Cells[0, i];
      for j := 0 to MountVolumes.Count - 1 do
      begin
         if MountVolumes[j] = Volume then
         begin
            MountPoint := MountPoints[j];

            // convert MountPoint into a human readable string
            for Drive := 'a' to 'z' do
            begin
               p := Pos(VolumeLetter[Drive], MountPoint);
               if p > 0 then
               begin
                  Delete(MountPoint, 1, p + Length(VolumeLetter[Drive]));
                  MountPoint := UpperCase(Drive) + ':' + MountPoint;
               end;
            end;

            if Length(VolumeGrid.Cells[3, i]) > 0 then
            begin
               VolumeGrid.Cells[3, i] := VolumeGrid.Cells[3, i] + ';' + MountPoint;
            end
            else
            begin
               VolumeGrid.Cells[3, i] := MountPoint;
            end;
         end;
      end;
   end;


end;


procedure TMainForm.TabSheet2aShow(Sender: TObject);
begin
   PrepareStep2a;
end;

procedure TMainForm.PrepareStep2a;
var
   Buffer : String;
   h : THandle;
   FileSystem : String;
begin
   if VolumeGrid.Enabled then
   begin
      exit;
   end;

   Global.Wait;
   try

      // get a list of volumes for the assignments....
      LoadVolume;
      SetLength(Buffer, 1024);

      h := JFindFirstVolume(PChar(Buffer), Length(Buffer));
      while h <> INVALID_HANDLE_VALUE do
      begin
         SetLength(Buffer, strlen(PChar(Buffer)));
         Debug('Find volume: ' + Buffer);

         // see what kind of filesystem this is...
         FileSystem := IdentifyVolumeFS(Buffer);

         if Length(FileSystem) > 0 then
         begin
            if VolumeGrid.Enabled then
            begin
               VolumeGrid.RowCount := VolumeGrid.RowCount + 1;
            end
            else
            begin
               VolumeGrid.Enabled := True;
            end;
            Buffer := Copy(Buffer, 12, Length(Buffer) - 13);
            VolumeGrid.Cells[0, VolumeGrid.RowCount - 1] := Buffer;
            VolumeGrid.Cells[1, VolumeGrid.RowCount - 1] := FileSystem;
         end;

         SetLength(Buffer, 1024);
         if not JFindNextVolume(h, PChar(Buffer), Length(Buffer)) then
         begin
            JFindVolumeClose(h);
            h := INVALID_HANDLE_VALUE;
         end;
      end;

      debug('Now checking mount points...');
      IdentifyVolumeMounts;

      if not VolumeGrid.Enabled then
      begin
         VolumeGrid.Cells[0, 1] := 'No EXT volumes found';
      end;
   finally
      Global.WaitDone;
   end;
end;

procedure TMainForm.Button10Click(Sender: TObject);
begin
   ShellExecute(Handle, 'open', 'diskmgmt.msc', '', '', SW_SHOWDEFAULT);
end;

procedure TMainForm.Button11Click(Sender: TObject);
var
   Drive : String;
   Error : DWORD;
begin
   if VolumeGrid.Row > 0 then
   begin
      Drive := VolumeGrid.Cells[2, VolumeGrid.Row];
      if Length(Drive) = 1 then
      begin
         Drive := Drive + ':\';
         if MessageDlg('Do you want to delete the drive letter ' + Drive, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         begin
            if not JDeleteVolumeMountPoint(PChar(Drive)) then
            begin
               Error := GetLastError;
               if Error = 0 then
               begin
                  MessageDlg('The drive letter could not be deleted.  Try using step 2b to remove it', mtError, [mbOK], 0);
               end
               else
               begin
                  MessageDlg('Error deleting drive letter ' + IntToStr(Error) + ' ' + SysErrorMessage(Error), mtError, [mbOK], 0);
               end;
            end;
         end;
      end;
   end;

   VolumeGrid.RowCount := 2;
   VolumeGrid.Enabled := False;
   PrepareStep2a;

end;

procedure TMainForm.Button12Click(Sender: TObject);
var
   MountPoint : String;
begin
   if VolumeGrid.Row > 0 then
   begin
      MountPoint := VolumeGrid.Cells[3, VolumeGrid.Row];
      if Length(MountPoint) > 0 then
      begin
         if MessageDlg('Do you want to unmount ' + MountPoint, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         begin
            if not JDeleteVolumeMountPoint(PChar(MountPoint)) then
            begin
               MessageDlg('Error unmounting drive ' + IntToStr(GetLastError) + ' ' + SysErrorMessage(GetLastError), mtError, [mbOK], 0);
            end;
         end;
      end;
   end;

   VolumeGrid.RowCount := 2;
   VolumeGrid.Enabled := False;
   PrepareStep2a;

end;

procedure TMainForm.UnmountAll(Volume : String);
var
   MountPoints    : TStringList;
   i              : Integer;
   Buffer         : String;
begin
   MountPoints := TStringList.Create;

   GetListOfMountPoints(MountPoints);
   for i := 0 to MountPoints.Count - 1 do
   begin
      SetLength(Buffer, 1024);
      if JGetVolumeNameForVolumeMountPoint(PChar(MountPoints[i]), PChar(Buffer), Length(Buffer)) then
      begin
         SetLength(Buffer, StrLen(PChar(Buffer)));
         if Length(Buffer) > 0 then
         begin
            Buffer := Copy(Buffer, 12, Length(Buffer) - 13);
         end;

         if Buffer = Volume then
         begin
            JDeleteVolumeMountPoint(PChar(MountPoints[i]));
         end;
      end;
   end;
end;

procedure TMainForm.VolumeGridDblClick(Sender: TObject);
var
   NewLetterDlg : TNewLetterDlg;
   NewLetter    : String;
   Drive        : String;
   D            : Char;
   DriveString  : String;
   Error        : DWORD;
   Volume       : String;
   Changed      : Boolean;
   Buffer       : String;
   Available    : Boolean;

   NewPathDlg   : TNewPathDlg;
   CurrentPath  : String;
   NewPath      : String;
begin
   Changed := False;
   if VolumeGrid.Row > 0 then
   begin
      if VolumeGrid.Col = 2 then
      begin
         NewLetterDlg := TNewLetterDlg.Create(self);
         try
            Drive := VolumeGrid.Cells[2, VolumeGrid.Row];
            if Length(Drive) = 2 then
            begin
               MessageDlg('This drive assignment has been made using a DOS Device alias.  Use Step 2b to delete it', mtInformation, [mbOK], 0);
               exit;
            end;

            NewLetterDlg.VolumeLabel.Caption := VolumeGrid.Cells[0, VolumeGrid.Row];
            if Length(Drive) > 0 then
            begin
               NewLetterDlg.OldLetterLabel.Caption := Drive + ':';
            end
            else
            begin
               NewLetterDlg.OldLetterLabel.Caption := 'None';
            end;

            NewLetterDlg.LetterCombo.Items.Clear;
            NewLetterDlg.LetterCombo.Items.Add('None');
            // populate the combo box with the available drive letters
            for D := 'a' to 'z' do
            begin
               DriveString := D + ':\';
               Available := True;

               if CompareText(D, Drive) <> 0 then
               begin
                  SetLength(Buffer, 1024);
                  if JGetVolumeNameForVolumeMountPoint(PChar(DriveString), PChar(Buffer), Length(Buffer)) then
                  begin
                     SetLength(Buffer, strlen(PChar(Buffer)));
                     if Length(Buffer) > 0 then
                     begin
                        Available := False;
                     end;
                  end;
               end;

               if Available then
               begin
                  NewLetterDlg.LetterCombo.Items.Add(UpperCase(D + ':'));
               end;
            end;

            NewLetterDlg.LetterCombo.Text := NewLetterDlg.OldLetterLabel.Caption;
            if NewLetterDlg.ShowModal = mrOK then
            begin
               // check if the
               if NewLetterDlg.LetterCombo.Text = 'None' then
               begin
                  NewLetter := '';
               end
               else
               begin
                  NewLetter := Copy(NewLetterDlg.LetterCombo.Text, 1, 1);
               end;

               // is the new letter the same as the old one?
               if NewLetter = Drive then
               begin
                  // nothing to do...
               end
               else
               begin
                  // delete the old one
                  if Length(Drive) = 1 then
                  begin
                     Drive := Drive + ':\';
                     if MessageDlg('Do you want to delete the drive letter ' + Drive, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                     begin
                        if JDeleteVolumeMountPoint(PChar(Drive)) then
                        begin
                           Changed := True;
                        end
                        else
                        begin
                           Error := GetLastError;
                           if Error = 0 then
                           begin
                              MessageDlg('The drive letter could not be deleted.  Try using step 2b to remove it', mtError, [mbOK], 0);
                           end
                           else
                           begin
                              MessageDlg('Error deleting drive letter ' + IntToStr(Error) + ' ' + SysErrorMessage(Error), mtError, [mbOK], 0);
                           end;
                        end;
                     end;
                  end;
                  // create the new one
                  if Length(NewLetter) = 1 then
                  begin
                     NewLetter := NewLetter + ':\';
                     Volume := '\\?\Volume{' + VolumeGrid.Cells[0, VolumeGrid.Row] + '}\';
                     if JSetVolumeMountPoint(PChar(NewLetter), PChar(Volume)) then
                     begin
                        Changed := True;
                     end
                     else
                     begin
                        Error := GetLastError;
                        MessageDlg('Error creating drive letter ' + IntToStr(Error) + ' ' + SysErrorMessage(Error), mtError, [mbOK], 0);
                     end;
                  end;
               end;
            end;
         finally
            NewLetterDlg.Free;
         end;
      end
      else if VolumeGrid.Col = 3 then
      begin
         // change the mount path...
         Volume := VolumeGrid.Cells[0, VolumeGrid.Row];
         CurrentPath := VolumeGrid.Cells[3, VolumeGrid.Row];

         NewPathDlg := TNewPathDlg.Create(Self);
         try
            NewPathDlg.VolumeLabel.Caption := Volume;
            if Length(CurrentPath) > 0 then
            begin
               NewPathDlg.OldPathLabel.Caption := CurrentPath;
            end
            else
            begin
               NewPathDlg.OldPathLabel.Caption := 'None';
            end;

            if NewPathDlg.ShowModal = mrOK then
            begin
               if NewPathDlg.ReplaceCheckBox.Checked then
               begin
                  // unmount from all mount points...
                  UnmountAll(Volume);
                  Changed := True;
               end;

               NewPath := NewPathDlg.NewPathEdit.Text;
               if Length(NewPath) > 0 then
               begin
                  if NewPath[Length(NewPath)] <> '\' then
                  begin
                     NewPath := NewPath + '\';
                  end;
                  Volume := '\\?\Volume{' + VolumeGrid.Cells[0, VolumeGrid.Row] + '}\';
                  if JSetVolumeMountPoint(PChar(NewPath), PChar(Volume)) then
                  begin
                     Changed := True;
                  end
                  else
                  begin
                     Error := GetLastError;
                     MessageDlg('Error creating mount point ' + IntToStr(Error) + ' ' + SysErrorMessage(Error), mtError, [mbOK], 0);
                  end;
               end;
            end;
         finally
            NewPathDlg.Free;
         end;
      end;
   end;
   if Changed then
   begin
      VolumeGrid.RowCount := 2;
      VolumeGrid.Enabled := False;
      PrepareStep2a;
   end;
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
   VolumeGrid.RowCount := 2;
   VolumeGrid.Enabled := False;
   PrepareStep2a;
end;

procedure TMainForm.UpgradeButtonClick(Sender: TObject);
begin
   UnInstallButtonClick(UnInstallButton);
   InstallButtonClick(InstallButton);
end;

end.
